/*
	MegaCracker - Cracks the password hash from a confirmation link.
	Copyright (C) 2013 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef MEGA_HASH_CHECKER_H
#define MEGA_HASH_CHECKER_H

#include <list>
#include <string>
#include "common.h"
#include "messagequeue.h"
#include "msgqueuenodetype.h"
#include "thread.h"

class MegaHashChecker : public Thread
{
public:
	MegaHashChecker(MessageQueue<msgQueueNodeType> *inQueue, MessageQueue<msgQueueNodeType> *outQueue,
	                std::list<std::pair<uint32_t*,std::string> > &hashes, FILE *fout, FILE *foutCracked);
	~MegaHashChecker();

	int stopRunning();

protected:
	void *threadFunc();

private:
	MessageQueue<msgQueueNodeType>               *m_inQueue;
	MessageQueue<msgQueueNodeType>               *m_outQueue;
	std::list<std::pair<uint32_t*,std::string> > *m_hashes;
	FILE                                         *m_fout;
	FILE                                         *m_foutCracked;
	uint32_t                                      m_run;
};

#endif
