/*
	MegaCracker - Cracks the password hash from a confirmation link.
	Copyright (C) 2013 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef READER_H
#define READER_H

#include <list>
#include <string>
#include "common.h"
#include "messagequeue.h"
#include "msgqueuenodetype.h"
#include "thread.h"

class Reader : public Thread
{
public:
	Reader(MessageQueue<msgQueueNodeType> *inQueue, MessageQueue<msgQueueNodeType> *outQueue, FILE *fin);
	~Reader();

	int stopRunning();
	const uint32_t read() { return m_read; }

protected:
	void *threadFunc();

private:
	MessageQueue<msgQueueNodeType> *m_inQueue;
	MessageQueue<msgQueueNodeType> *m_outQueue;
	FILE                           *m_fin;
	uint32_t                        m_read;
	uint32_t                        m_run;
};

#endif
