/*
	MegaCracker - Cracks the password hash from a confirmation link.
	Copyright (C) 2013 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "thread.h"
#include <stdio.h>

Thread::Thread()
	: m_started(0)
{
}

void Thread::waitForStopRunning()
{
	THREAD_WAIT(m_thread);
}

int Thread::start()
{
	int ret = 1;

	if (m_started)
	{
		reportError("Thread::start(): Already started\n");
	}
	else
	{
		m_started = 1;
		ret = THREAD_CREATE(m_thread, Thread::callThreadFunc, this);
		if (ret)
		{
			reportError("Thread::start(): Thread creation failed: %d\n", ret);
		}
	}
	return ret;
}

void *Thread::callThreadFunc(void *arg)
{
	return ((Thread*) arg)->threadFunc();
}
