/*
	MegaCracker - Cracks the password hash from a confirmation link.
	Copyright (C) 2013 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef THREAD_H
#define THREAD_H

#include "threads.h"
#include "messagequeue.h"

class Thread
{
public:
	Thread();
	virtual ~Thread() {}
	virtual int stopRunning() = 0;
	void waitForStopRunning();
	int start();

protected:
	virtual void *threadFunc() = 0;

private:
	static void *callThreadFunc(void *arg);
	
	THREAD   m_thread;
	uint32_t m_started;
};

#endif
